diff --git a/contrib/bloom/t/001_wal.pl b/contrib/bloom/t/001_wal.pl
new file mode 100644
index dbba198..1b319c9
*** a/contrib/bloom/t/001_wal.pl
--- b/contrib/bloom/t/001_wal.pl
*************** SELECT * FROM tst WHERE i = 7 AND t = 'e
*** 32,39 ****
  );
  
  	# Run test queries and compare their result
! 	my $master_result = $node_master->psql("postgres", $queries);
! 	my $standby_result = $node_standby->psql("postgres", $queries);
  
  	is($master_result, $standby_result, "$test_name: query result matches");
  }
--- 32,39 ----
  );
  
  	# Run test queries and compare their result
! 	my $master_result = $node_master->safe_psql("postgres", $queries);
! 	my $standby_result = $node_standby->safe_psql("postgres", $queries);
  
  	is($master_result, $standby_result, "$test_name: query result matches");
  }
*************** $node_standby->init_from_backup($node_ma
*** 54,65 ****
  $node_standby->start;
  
  # Create some bloom index on master
! $node_master->psql("postgres", "CREATE EXTENSION bloom;");
! $node_master->psql("postgres", "CREATE TABLE tst (i int4, t text);");
! $node_master->psql("postgres",
  "INSERT INTO tst SELECT i%10, substr(md5(i::text), 1, 1) FROM generate_series(1,100000) i;"
  );
! $node_master->psql("postgres",
  	"CREATE INDEX bloomidx ON tst USING bloom (i, t) WITH (col1 = 3);");
  
  # Test that queries give same result
--- 54,65 ----
  $node_standby->start;
  
  # Create some bloom index on master
! $node_master->safe_psql("postgres", "CREATE EXTENSION bloom;");
! $node_master->safe_psql("postgres", "CREATE TABLE tst (i int4, t text);");
! $node_master->safe_psql("postgres",
  "INSERT INTO tst SELECT i%10, substr(md5(i::text), 1, 1) FROM generate_series(1,100000) i;"
  );
! $node_master->safe_psql("postgres",
  	"CREATE INDEX bloomidx ON tst USING bloom (i, t) WITH (col1 = 3);");
  
  # Test that queries give same result
*************** test_index_replay('initial');
*** 68,79 ****
  # Run 10 cycles of table modification. Run test queries after each modification.
  for my $i (1 .. 10)
  {
! 	$node_master->psql("postgres", "DELETE FROM tst WHERE i = $i;");
  	test_index_replay("delete $i");
! 	$node_master->psql("postgres", "VACUUM tst;");
  	test_index_replay("vacuum $i");
  	my ($start, $end) = (100001 + ($i - 1) * 10000, 100000 + $i * 10000);
! 	$node_master->psql("postgres",
  "INSERT INTO tst SELECT i%10, substr(md5(i::text), 1, 1) FROM generate_series($start,$end) i;"
  	);
  	test_index_replay("insert $i");
--- 68,79 ----
  # Run 10 cycles of table modification. Run test queries after each modification.
  for my $i (1 .. 10)
  {
! 	$node_master->safe_psql("postgres", "DELETE FROM tst WHERE i = $i;");
  	test_index_replay("delete $i");
! 	$node_master->safe_psql("postgres", "VACUUM tst;");
  	test_index_replay("vacuum $i");
  	my ($start, $end) = (100001 + ($i - 1) * 10000, 100000 + $i * 10000);
! 	$node_master->safe_psql("postgres",
  "INSERT INTO tst SELECT i%10, substr(md5(i::text), 1, 1) FROM generate_series($start,$end) i;"
  	);
  	test_index_replay("insert $i");
